--- WebRssCode  (revision 2798)
+++ WebRssCode  (working copy)
@@ -52,30 +52,32 @@
 </property>
 </object>
 <content>{pre}
+#set ($hiddenSpaces = ["XWiki", "Admin", "Panels"])
+#set ($hiddenPages = ["Main.WebRss", "Main.WebSearch", "Main.BlogRss","Main.Test", "Blog.Macros", "Main.TagsRss", "Main.WikiLaunch", "Main.RegisterNewUserAction", "Main.SpaceIndex", "Blog.Category", "Main.RecentMembers", "Main.Tags", "Main.Dashboard", "Main.PersonalRSS", "Blog.Categories"])
 $context.setCacheDuration(1800)
 &lt;rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns="http://purl.org/rss/1.0/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:wiki="http://purl.org/rss/1.0/modules/wiki/" xmlns:html="http://www.w3.org/1999/xhtml"&gt;
 &lt;channel rdf:about="$baseurl"&gt;
 &lt;title&gt;
 #if($title)
-$title
+  $title
 #else
-$request.serverName
+  $request.serverName
 #end
 &lt;/title&gt;
 &lt;link&gt;$baseurl&lt;/link&gt;
 &lt;description&gt;
 #if($description)
-$description
+  $description
 #else
-$request.serverName
+  $request.serverName
 #end
 &lt;/description&gt;
 #set($logourl = $xwiki.getSkinFile($xwiki.getSkinPreference('logo', 'logo.png')))
 #set($port = "")
-#if(($request.scheme == "http") &amp;&amp; ($request.serverPort != 80))
-#set($port = ":${request.serverPort}")
-#elseif(($request.scheme == "https") &amp;&amp; ($request.serverPort != 443))
-#set($port = ":${request.serverPort}")
+#if(($request.scheme == "http") && ($request.serverPort != 80))
+  #set($port = ":${request.serverPort}")
+#elseif(($request.scheme == "https") && ($request.serverPort != 443))
+  #set($port = ":${request.serverPort}")
 #end
 #set($logourl = "${request.scheme}://${request.serverName}${port}$logourl")
 &lt;image rdf:resource="$logourl"/&gt;
@@ -86,17 +88,19 @@
 &lt;items&gt;
 &lt;rdf:Seq&gt;
 #if(!$list)
-#if(!$sql)
-#set($sql = "where 1=1 order by doc.date desc")
+  #if(!$sql)
+    #set($sql = "where 1=1 order by doc.date desc")
+  #end
+  #set($list = $xwiki.searchDocuments($sql, 50, 0))
 #end
-#set($list = $xwiki.searchDocuments($sql, 20, 0))
-#end
 #set($list = $xwiki.wrapDocs($list))
 #foreach ($currentdoc in $list)
-#if($xwiki.hasAccessLevel("view", "${context.database}:${currentdoc.fullName}"))
-&lt;rdf:li rdf:resource="$currentdoc.getExternalURL('view', "language=${currentdoc.realLanguage}")" /&gt;
+  #if(!$hiddenPages.contains($currentdoc.fullName) && !$hiddenSpaces.contains($currentdoc.space))
+    #if($xwiki.hasAccessLevel("view", "${context.database}:${currentdoc.fullName}"))
+      &lt;rdf:li rdf:resource="$currentdoc.getExternalURL('view', "language=${currentdoc.realLanguage}")" /&gt;
+    #end
+  #end
 #end
-#end
 &lt;/rdf:Seq&gt;
 &lt;/items&gt;
 &lt;/channel&gt;
@@ -106,30 +110,31 @@
   &lt;url&gt;$logourl&lt;/url&gt;
 &lt;/image&gt;
 #foreach ($currentdoc in $list)
-#if($xwiki.hasAccessLevel("view", "${context.database}:${currentdoc.fullName}"))
-
-#set ($url = $currentdoc.getExternalURL('view', "language=${currentdoc.realLanguage}"))
-#if ($currentdoc.content.length() &lt; 255)
-#set ($length = $currentdoc.content.length())
-#else
-#set ($length = 255)
+  #if(!$hiddenPages.contains($currentdoc.fullName) && !$hiddenSpaces.contains($currentdoc.space))
+    #if($xwiki.hasAccessLevel("view", "${context.database}:${currentdoc.fullName}"))
+      #set ($url = $currentdoc.getExternalURL('view', "language=${currentdoc.realLanguage}"))
+      #if ($currentdoc.content.length() &lt; 255)
+        #set ($length = $currentdoc.content.length())
+      #else
+        #set ($length = 255)
+      #end
+      &lt;item rdf:about="$url"&gt;
+        &lt;title&gt;$xwiki.getXMLEncoded(${currentdoc.displayTitle})&lt;/title&gt;
+        &lt;link&gt;$url&lt;/link&gt;
+        &lt;description&gt;Version $currentdoc.version edited by $xwiki.getXMLEncoded($xwiki.getUserName($currentdoc.author,     false)) on $currentdoc.date&lt;/description&gt;
+        #set($tz = $xwiki.formatDate($currentdoc.date, "Z"))
+        #set($tz = "${tz.substring(0, 3)}:${tz.substring(3)}")
+        &lt;dc:date&gt;$xwiki.formatDate($currentdoc.date, "yyyy-MM-dd")T$xwiki.formatDate($currentdoc.date, "hh:mm:ss")$tz&lt;/dc:date&gt;
+        &lt;dc:creator&gt;$xwiki.getXMLEncoded($xwiki.getUserName($currentdoc.creator, false))&lt;/dc:creator&gt;
+        &lt;dc:contributor&gt;
+          &lt;rdf:Description link=""&gt;
+            &lt;rdf:value&gt;$xwiki.getXMLEncoded($xwiki.getUserName($currentdoc.author, false))&lt;/rdf:value&gt;
+          &lt;/rdf:Description&gt;
+        &lt;/dc:contributor&gt;
+      &lt;/item&gt;
+    #end
+  #end
 #end
-&lt;item rdf:about="$url"&gt;
-&lt;title&gt;$xwiki.getXMLEncoded(${currentdoc.displayTitle})&lt;/title&gt;
-&lt;link&gt;$url&lt;/link&gt;
-&lt;description&gt;Version $currentdoc.version edited by $xwiki.getXMLEncoded($xwiki.getUserName($currentdoc.author, false)) on $currentdoc.date&lt;/description&gt;
-#set($tz = $xwiki.formatDate($currentdoc.date, "Z"))
-#set($tz = "${tz.substring(0, 3)}:${tz.substring(3)}")
-&lt;dc:date&gt;$xwiki.formatDate($currentdoc.date, "yyyy-MM-dd")T$xwiki.formatDate($currentdoc.date, "hh:mm:ss")$tz&lt;/dc:date&gt;
-&lt;dc:creator&gt;$xwiki.getXMLEncoded($xwiki.getUserName($currentdoc.creator, false))&lt;/dc:creator&gt;
-&lt;dc:contributor&gt;
-&lt;rdf:Description link=""&gt;
-&lt;rdf:value&gt;$xwiki.getXMLEncoded($xwiki.getUserName($currentdoc.author, false))&lt;/rdf:value&gt;
-&lt;/rdf:Description&gt;
-&lt;/dc:contributor&gt;
-&lt;/item&gt;
-#end
-#end
 &lt;/rdf:RDF&gt;
 {/pre}</content>
 </xwikidoc>